import numpy as np
import h5py as h5

nchan=13
nfov=90
def limb_adjust(obs, flagin=None):
    # shape of obs: [nscan, nfov, nchan]
    fname='Limb-Coef-201408.h5'
    with h5.File(fname, 'r') as infile:
        pred=infile['predictors'][()]
        coef=infile['coef'][()]
        cept=infile['intercept'][()]
        TBj =infile['TB_FOV_mean'][()]
        
    if not flagin is None:
        for ifov in range(nfov):
            TBj[ifov,:]=obs[:,ifov,:][flagin[:,ifov],:].mean(axis=0)

    sim=obs.copy()
    for ichan in range(nchan):
        npred=(pred[:,ichan]>=0).sum()
        for ifov in range(nfov):
            chanlist=[pred[i,ichan] for i in range(npred)]
            x=obs[:,ifov,chanlist].copy()
            for i in range(npred): x[:,i]-=TBj[ifov,pred[i,ichan]]
            sim[:,ifov,ichan]=np.dot(x, coef[:npred,ifov,ichan])+cept[ifov,ichan]

    return sim
